<?

  include_once("./portal_data/functions.php");

  // Menpunkte fr diese Seite
  $site_menu[0] = "News,news.php";
  $site_menu[1] = "Themen,news.php?aktion=themen";
  $site_menu[2] = "News schreiben,news.php?aktion=schreiben";

  include_once("./portal_data/header.php");

  // Datenbank Verbindungen herstellen ...
  $news_db = bdbc("./datenbanken/news_main");
  $themen_db = bdbc("./datenbanken/news_themen");
  $kommentare_db = bdbc("./datenbanken/news_kommentare");

  // Funktionen ....
  function GetInfo($reihe,$spalte,$datenbank)
  {
    if(!($reihe == .1)&&!($spalte == .1))
    {
      $eintrag = explode(",",$datenbank[$reihe]);
      $ruckgabe = $eintrag[$spalte];
    }
    else
    {
      if(($reihe == .1)&&!($spalte == .1))
      {
        for($i=0,$x=0;$i<sizeof($datenbank);$i++)
        {
          if(($datenbank[$i] != "")&&($datenbank[$i] != "\n"))
          {
            $eintrag = explode(",",$datenbank[$i]);
            $back[$x] = $eintrag[$spalte];
            $x++;
          }
        }
        $ruckgabe = implode(",",$back);
      }
      if(!($reihe == .1)&&($spalte == .1))
      {
        $ruckgabe = $datenbank[$reihe];
      }
    }

  return $ruckgabe;
  }

  function ThemaInfo($thema,$info,$db)
  {
    for($i=0;$i<sizeof($db);$i++)
    {
      $eintrag = explode(",",$db[$i]);
      if($eintrag[0] == $thema) return $eintrag[$info];
    }
  }

  function ShortText($lange,$text)
  {
    $words = explode(" ",$text);
    $back = "";
    for($i=0;($i<$lange)&&($i<sizeof($words));$i++) $back .= " ".$words[$i];
    if($lange < sizeof($words)) $back .= " ...";

  return $back;
  }

  function MoreText($lange,$text)
  {
    $words = explode(" ",$text);
    if(sizeof($words) > $lange) return true; else return false;
  }

  function XKommentare($themenid,$db)
  {
    $kommentare = 0;
    for($i=0;$i<sizeof($db);$i++)
    {
      if(($db[$i] != "")&&($db[$i] != "\n"))
      {
        $eintrag = explode(",",$db[$i]);
        if($eintrag[1] == $themenid) $kommentare++;
      }
    }
  return $kommentare;
  }

  function NumberOfNews($id,$db)
  {
    $back = 0;
    for($i=0;$i<sizeof($db);$i++)
    {
      if(($db[$i] != "")&&($db[$i] != "\n"))
      {
        $eintrag = explode(",",$db[$i]);
        if(($eintrag[1] == $id)&&($eintrag[3] != "waiting")&&($eintrag[2] <= time())) $back++;
      }
    }
  return $back;
  }

  function CountIntern($id,$db)
  {
    for($i=0;$i<sizeof($db);$i++)
    {
      if(($db[$i] != "")&&($db[$i] != "\n"))
      {
        $eintrag = explode(",",$db[$i]);
        if($eintrag[0] == $id)
        {
          $eintrag[5]++;
          $db[$i] = implode(",",$eintrag);
          break;
        }
      }
    }
    //my_speichern("./modules/mod_blind_news/news.store",implode("",$db));
    bdbs("./datenbanken/news_main",implode("",$db));
  }

  function NewsPosten($titel,$autor,$thema,$beitrag,$db,$datei,$modus,$zeit)
  {
    if(($titel != "")&&($autor != "")&&($beitrag != ""))
    {
      ?>
        <table width="100%" cellspacing=0 cellpadding=3 class="t_002">
          <tr>
            <td align=center valing=middle>
              <b>Danke fr ihren Beitrag!</b><br>
              Er wird in Krze vom Administrator dieser Seite berprft.
            </td>
          </tr>
        </table>
        <br>
      <?
      $db[sizeof($db)] = GetID($db).",".$thema.",".$zeit.",".$modus.",".TextEncode($autor).",0,".TextEncode($titel).",".TextEncode($beitrag).",\n";
      bdbs($datei,implode("",$db));
    }

  return $db;
  }

  // Vorbereiten ...
  $news_ps = Info("POSTS_PER_SITE",$usr_db);
  $lange = 80;
  $news_db = sbdb($news_db,2);

  setlocale("LC_ALL","ge");
  //setlocale("LC_TIME","ge");
  if(!$aktion)
  {
    // News schreiben ...
    if($posten)
    {
      $news_db = NewsPosten($titel,$autor,$thema,$beitrag,$news_db,"./datenbanken/news_main","waiting",time());
      $news_db = sbdb($news_db,2);
      if(Info("MAILONACTION",$db_site_cfg) == 1)
      {
        $mail = "Titel: $titel<br>\nVon: $autor<br>\n<br>\n$beitrag";
        $from = "News [BlindNews] - Autorisation bentigt";
        $subject = "News [$titel von $autor]";
        mail(Info("MAIL",$db_site_cfg),"$subject","$mail","From: $from\nContent-Type: text/html");
      }
    }
    // Ende News_schreiben ...

    echo "<center>";

    for($i=sizeof($news_db),$d=0;($d<$news_ps)&&($i>=0);$i--)
    {
      if(($news_db[$i] != "")&&($news_db[$i] != "\n")&&(GetInfo($i,3,$news_db) == "show")&&(GetInfo($i,2,$news_db) <= time()))
      {
        ?><table width="100%" cellpadding=0 cellspacing=0 class="t_001"><tr><td><table width="100%" cellpadding=3 cellspacing=0><?
        echo "<tr><td class=\"t_0000\"><b>".TextDecode(GetInfo($i,6,$news_db))."</b></td></tr>";

        echo "<tr><td class=\"t_0000\">Geschrieben von <i>".TextDecode(GetInfo($i,4,$news_db))."</i> am ".strftime("%A, den %d.%m.%Y",GetInfo($i,2,$news_db))." um ".strftime("%H:%M",GetInfo($i,2,$news_db)).".</td></tr>";

        echo "<tr><td class=\"t_000\"><a href=\"news.php?aktion=showthema&themenid=".GetInfo($i,1,$news_db)."\"><IMG align=left alt=\"".ThemaInfo(GetInfo($i,1,$news_db),1,$themen_db)."\" border=0 hspace=5 src=\"bilder/".ThemaInfo(GetInfo($i,1,$news_db),2,$themen_db)."\" vspace=5></a>".DecodeLink(TextDecode(ShortText($lange,GetInfo($i,7,$news_db))))."</td></tr>";

        echo "<tr><td class=\"t_0000\">=&gt; ( ";
        if(MoreText($lange,GetInfo($i,7,$news_db))) echo "<a href=\"news.php?aktion=detail&id=".GetInfo($i,0,$news_db)."\">mehr lesen ...</a> |";
        echo " <a href=\"news.php?aktion=detail&id=".GetInfo($i,0,$news_db)."#kommentare\">".XKommentare(GetInfo($i,0,$news_db),$kommentare_db)." Kommentare</a> ) ".GetInfo($i,5,$news_db)." mal gelesen.</td></tr>";
        ?></table></td></tr></table><br><?
        $d++;
      }
    }
    echo "</center>";
  }
  else
  {
    switch($aktion)
    {
    case "detail" : {
                      // Counter ...
                      if(!$begrenzung&&!$listmode&&!$speichern) CountIntern($id,$news_db);
                      // Counter Ende

                      // Speichern eines Kommentars
                      if(($name != "")&&($kommentar != "")&&($speichern == 1))
                      {
                        $kommentare_db = sbdb($kommentare_db,2);
                        $kommentar_eintrag = explode(",",$kommentare_db[sizeof($kommentare_db)-1]);
                        $kommentar_id = GetID($kommentare_db);
                        $kommentare_db[sizeof($kommentare_db)] = $kommentar_id.",".$id.",".time().",".TextEncode($name).",".TextEncode($kommentar).",\n";
                        bdbs("./datenbanken/news_kommentare",implode("",$kommentare_db));
                        if(Info("MAILONACTION",$db_site_cfg) == 1)
                        {
                          $mail = "Folgender Kommentar wurde geposted:<br>\n<br>\nVon: ".$name."<br>\n<br>\n".$kommentar;
                          $from = "News [BlindNews - Kommentar]";
                          $subject = "Kommentar Geposted: [Von ".$name."]";
                          mail(Info("MAIL",$db_site_cfg),"$subject","$mail","From: $from\nContent-Type: text/html");
                        }
                      }
                      // Ende speichern

                      echo "<center>";
                      for($i=0;$i<sizeof($news_db);$i++)
                      {
                        if(($news_db[$i] != "")&&($news_db[$i] != "\n")&&(GetInfo($i,0,$news_db) == $id))
                        {
                          ?><table width="100%" cellpadding=3 cellspacing=0 class="t_001"><?
                          echo "<tr><td class=\"t_0000\"><b>".TextDecode(GetInfo($i,6,$news_db))."</b></td></tr>";

                          echo "<tr><td class=\"t_000\"><a href=\"news.php?aktion=showthema&themenid=".GetInfo($i,1,$news_db)."\"><IMG align=right alt=\"".ThemaInfo(GetInfo($i,1,$news_db),1,$themen_db)."\" border=0 hspace=5 src=\"bilder/".ThemaInfo(GetInfo($i,1,$news_db),2,$themen_db)."\" vspace=5></a>".DecodeLink(TextDecode(GetInfo($i,7,$news_db)))."</td></tr>";

                          echo "<tr><td class=\"t_0000\">Geschrieben von <i>".TextDecode(GetInfo($i,4,$news_db))."</i> am ".strftime("%A, den %d.%m.%Y",GetInfo($i,2,$news_db))." um ".strftime("%H:%M",GetInfo($i,2,$news_db)).".";
                          ?></table><br><?

                          ?><a name="kommentare"><table width="100%" cellpadding=3 cellspacing=0><?
                          echo "<tr><td class=\"t_0001\" align=\"center\"><b>Newsbeitrag:</b> ".TextDecode(GetInfo($i,6,$news_db))." | ".XKommentare(GetInfo($i,0,$news_db),$kommentare_db)." Kommentar(e)</td></tr>";

                          echo "<tr><td class=\"t_0000\"><table width=\"100%\" cellpadding=0 cellspacing=0><tr><td valign=middle><form action=\"news.php?aktion=detail&id=".GetInfo($i,0,$news_db)."\" method=post>Begrenzung: <select name=\"begrenzung\"><option value=\"500\">keine<option value=\"5\" selected>5<option value=\"10\">10<option value=\"15\">15</select> <select name=\"listmode\"><option value=\"neu\" selected>Neue zuerst<option value=\"alt\">Alte zuerst</select> <input type=\"submit\" value=\"Aktualisieren\"></form></td><td valign=middle><form action=\"news.php?aktion=kommentieren&id=".GetInfo($i,0,$news_db)."\" method=post><input type=submit value=\"Kommentar schreiben\"></form></td></tr></table></td></tr>";

                          echo "<tr><td class=\"t_0001\"><center><font size=\"-1\">Fr den Inhalt der Kommentare sind die Verfasser verantwortlich.</font></center></td></tr>";

                          echo "<tr><td class=\"t_0000\">";
                          // Begin der Kommentarauflistung ...
                          if(!$begrenzung) $begrenzung = 5;
                          if(!$listmode) $listmode = "neu";
                          $kommentare_db = sbdb($kommentare_db,2);
                          if($listmode == "neu")
                          {
                            for($t=(sizeof($kommentare_db)-1),$z=0;($t>=0)&&($z<$begrenzung);$t--)
                            {
                              if(($kommentare_db[$t] != "")&&($kommentare_db[$t] != "\n"))
                              {
                                $eintrag = explode(",",$kommentare_db[$t]);
                                if($eintrag[1] == $id)
                                {
                                  ?><table width="100%" cellpadding=3 cellspacing=0><tr><?
                                  echo "<td width=\"30%\" valign=top><b>Von:</b> ".TextDecode($eintrag[3])."<br><b>Datum:</b> ".strftime("%d.%m.%Y",$eintrag[2])."<br><b>Uhrzeit:</b> ".strftime("%H:%M",$eintrag[2])." Uhr</td>";
                                  echo "<td width=\"70%\" valign=top>".TextDecode($eintrag[4])."</td>";
                                  ?></tr></table><br><?
                                  $z++;
                                }
                              }
                            }
                          }
                          if($listmode == "alt")
                          {
                            for($t=0,$z=0;($t<sizeof($kommentare_db))&&($z<$begrenzung);$t++)
                            {
                              if(($kommentare_db[$t] != "")&&($kommentare_db[$t] != "\n"))
                              {
                                $eintrag = explode(",",$kommentare_db[$t]);
                                if($eintrag[1] == $id)
                                {
                                  ?><table width="100%" cellpadding=3 cellspacing=0><tr><?
                                  echo "<td width=\"30%\" valign=top><b>Von:</b> ".TextDecode($eintrag[3])."<br><b>Datum:</b> ".strftime("%d.%m.%Y",$eintrag[2])."<br><b>Uhrzeit:</b> ".strftime("%H:%M",$eintrag[2])." Uhr</td>";
                                  echo "<td width=\"70%\" valign=top>".TextDecode($eintrag[4])."</td>";
                                  ?></tr></table><br><?
                                  $z++;
                                }
                              }
                            }
                          }
                          // Ende Kommentarauflistung ....
                          echo "</td></tr>";

                          ?></table><br><?
                          break;
                        }
                      }
                      echo "</center>";

                    break;
                    }
    case "themen" : {
                      echo "<b>Themenbersicht</b><br><br>";
                      for($t=0;$t<sizeof($themen_db);$t++)
                      {
                        if(($themen_db[$t] != "")&&($themen_db[$t] != "\n"))
                        {
                          ?><table width="100%" cellpaddin=5 cellspacing=0 class="t_001"><?
                          $eintrag = explode(",",$themen_db[$t]);
                          echo "<tr><td width=\"30%\" valign=middle align=center><a href=\"news.php?aktion=showthema&themenid=".GetInfo($t,0,$themen_db)."\"><img src=\"bilder/".$eintrag[2]."\" border=0></a></td><td valign=top class=\"t_003\"><b>".$eintrag[1]."</b><br><br>".str_replace("&komma;",",",$eintrag[3])."<br><br><hr width=\"100%\"><b>Status:</b><br><a href=\"news.php?aktion=showthema&themenid=".GetInfo($t,0,$themen_db)."\">".NumberOfNews($eintrag[0],$news_db)." Newsbeitrge</a></td></tr>";
                          ?></table><br><?
                        }
                      }

                    break;
                    }
    case "showthema" : {
                         echo "<table width=\"100%\" cellpadding=0 cellspacing=0 class=\"t_002\"><tr><td>";
                         for($t=0;$t<sizeof($themen_db);$t++)
                         {
                           if(($themen_db[$t] != "")&&($themen_db[$t] != "\n"))
                           {
                             $eintrag = explode(",",$themen_db[$t]);
                             if($eintrag[0] == $themenid)
                             {
                               echo "<b>".$eintrag[1]."</b><br><br>";
                               break;
                             }
                           }
                         }
                         echo "<IMG align=right alt=\"".$eintrag[1]."\" border=0 hspace=5 src=\"bilder/".$eintrag[2]."\" vspace=5>".str_replace("&komma;",",",$eintrag[3])."<hr width=\"100%\">";
                         if(!$start) $start = 0;
                         if(!$nr) $nr = 0;
                         for($z=$start,$s=0;($z<sizeof($news_db)&&($s < $news_ps));$z++)
                         {
                           if((GetInfo($z,1,$news_db) == $themenid)&&(GetInfo($z,3,$news_db) != "waiting")&&(GetInfo($z,2,$news_db) <= time()))
                           {
                             echo "<b>Titel:</b> <a href=\"news.php?aktion=detail&id=".GetInfo($z,0,$news_db)."\">".TextDecode(GetInfo($z,6,$news_db))."</a><br><b>Autor: </b>".TextDecode(GetInfo($z,4,$news_db))."<br><b>Datum: </b>".strftime("%A, den %d.%m.%Y",GetInfo($z,2,$news_db))."<br><b>Um: </b>".strftime("%H:%M",GetInfo($z,2,$news_db))."<br><br>";
                             $s++;
                             $nr++;
                           }
                         }
                         if($nr < NumberOfNews($themenid,$news_db)) echo "<center><a href=\"news.php?aktion=showthema&themenid=$themenid&start=$z&nr=$nr\">nchste Seite</a></center>";
                         echo "</td></tr></table>";

                       break;
                       }
    case "kommentieren" : {
                            if((chk_login($login_cookie,$usr_db)) || (Info("ANONYM_KOMMENTAR",$db_site_cfg) == 1))
                            {
                              echo "<center>";
                              for($i=0;$i<sizeof($news_db);$i++)
                              {
                                if(($news_db[$i] != "")&&($news_db[$i] != "\n")&&(GetInfo($i,0,$news_db) == $id))
                                {
                                  ?><table width="100%" cellpadding=3 cellspacing=0 class="t_001"><?
                                  echo "<tr><td class=\"t_0000\"><b>".TextDecode(GetInfo($i,6,$news_db))."</b></td></tr>";

                                  echo "<tr><td class=\"t_000\"><a href=\"news.php?aktion=showthema&themenid=".GetInfo($i,1,$news_db)."\"><IMG align=right alt=\"".ThemaInfo(GetInfo($i,1,$news_db),1,$themen_db)."\" border=0 hspace=5 src=\"bilder/".ThemaInfo(GetInfo($i,1,$news_db),2,$themen_db)."\" vspace=5></a>".TextDecode(GetInfo($i,7,$news_db))."</td></tr>";

                                  echo "<tr><td class=\"t_0000\">Geschrieben von <i>".TextDecode(GetInfo($i,4,$news_db))."</i> am ".strftime("%A, den %d.%m.%Y",GetInfo($i,2,$news_db))." um ".strftime("%H:%M",GetInfo($i,2,$news_db)).".</td></tr>";
                                  ?></table><br><?
                                }
                              }
                              ?><br><br>
                                <table width="100%" cellpadding=3 cellspacing=0 class="t_002"><tr><td>
                                <form action="news.php?aktion=detail" method="post">
                                  <input type="hidden" name="id" value="<? echo $id; ?>">
                                  <input type="hidden" name="speichern" value=1>
                                  <input type="hidden" name="begrenzung" value=5>
                                  <table width="100%" cellpadding=3 cellspacing=0 class="tabelle">
                                    <tr>
                                      <td width=150 valign="top"><b>Name:</b></td>
                                      <td>
                                        <?

                                          if(chk_login($login_cookie,$usr_db)) echo "<input type=\"text\" name=\"name\" size=30 value=\"".Info("USER_NICK",$usr_db)."\" readonly>";
                                          else echo "<input type=\"text\" name=\"name\" size=30 value=\"Anonymous\" readonly>";

                                        ?>
                                      </td>
                                    </tr>
                                    <tr>
                                      <td width=150 valign="top"><b>Kommentar:</b><br><br>HTML-Code ist nicht erlaubt.</td>
                                      <td><textarea name="kommentar" cols=60 rows=5></textarea></td>
                                    </tr>
                                  </table>
                                  <br>
                                  <input type="submit" value="Kommentar eintragen">
                                </form>
                                </td></tr></table>
                              </center><?
                            }
                            else
                            {
                              ?>
                              <center><br><br><b>Sorry</b>, aber nur registrierte User sind berechtigt Kommentare zu schreiben!</center>
                              <?
                            }

                          break;
                          }
    case "schreiben" : {
                        if((chk_login($login_cookie,$usr_db)) || (Info("ANONYM_BEITRAG",$db_site_cfg) == 1))
                        {
                          ?>
                          <center>
                            <form method="post" action="news.php">
                              <table width="100%" border=0 cellpadding=3 cellspacing=0 class="t_002">
                                <tr>
                                  <td width=120 valign=top><b>Titel:</b></td>
                                  <td valign=top><input type="text" name="titel" size=30></td>
                                </tr>
                                <tr>
                                  <td width=120 valign=top><b>Autor:</b></td>
                                  <td valign=top>
                                    <?

                                      if(chk_login($login_cookie,$usr_db)) echo "<input type=\"text\" name=\"autor\" size=30 value=\"".Info("USER_NICK",$usr_db)."\" readonly>";
                                      else echo "<input type=\"text\" name=\"autor\" size=30 value=\"Anonymous\" readonly>";

                                    ?>
                                  </td>
                                </tr>
                                <tr>
                                  <td width=120 valign=top><b>Thema:</b></td>
                                  <td valign=top>
                                    <select name="thema">
                                      <?
                                        for($u=0;$u<sizeof($themen_db);$u++)
                                        {
                                          if(($themen_db[$u] != "")&&($themen_db[$u] != "\n"))
                                          {
                                            $themen_eintrag = explode(",",$themen_db[$u]);
                                            echo "<option value=\"$themen_eintrag[0]\">$themen_eintrag[1]";
                                          }
                                        }
                                      ?>
                                    </select>
                                  </td>
                                </tr>
                                <tr>
                                  <td width=120 valign=top><b>News-Beitrag:</b></td>
                                  <td valign=top><textarea name="beitrag" rows=7 cols=60></textarea></td>
                                </tr>
                                <tr>
                                  <td width=120 valign=top><input type="hidden" name="posten" value=1>&nbsp;</td>
                                  <td valign=top><input type="submit" value="Senden"></td>
                                </tr>
                              </table>
                            </form>
                          </center>
                          <?
                        }
                        else
                        {
                          ?>
                          <center><br><br><b>Sorry</b>, aber nur registrierte User sind berechtigt News zu schreiben!</center>
                          <?
                        }

                       break;
                       }
    default : {
                echo "Sorry, die Aktion, die du gewhlt hast ist noch nicht implementiert.";

              break;
              }
    }
  }

  include_once("./portal_data/footer.php");

?>